#**************************************************************
# This .sdc file is created by Terasic Tool.
# Users are recommended to modify this file to match users logic.
#**************************************************************

#**************************************************************
# Create Clock
#**************************************************************
# CLOCK
create_clock -period 10 [get_ports CLK_100_B3A_p]
create_clock -period 10 [get_ports CLK_100_p]
create_clock -period "148.5MHz" [get_ports CLK_148M5_p]
create_clock -period 20 [get_ports CLK_50_B2D_p]
create_clock -period 20 [get_ports CLK_50_B2E_p]
create_clock -period 20 [get_ports CLK_50_B3A_p]
create_clock -period 20 [get_ports CLK_50_B3C_p]


# DDR4A
create_clock -period 30 [get_ports DDR4A_REFCLK_p]
# DDR4B
create_clock -period 30 [get_ports DDR4B_REFCLK_p]
# HDMI
create_clock -period 10 [get_ports HDMI_REFCLK_100_p]
create_clock -period "148.5MHz" [get_ports HDMI_REFCLK_148M5_p]
# FMCP
create_clock -period 10 [get_ports FMCP_GBTCLK_M2C_p[0]]
create_clock -period 10 [get_ports FMCP_GBTCLK_M2C_p[1]]
create_clock -period "156.25MHz" [get_ports FMCP_REFCLK_p[0]]
create_clock -period "184.32MHz" [get_ports FMCP_REFCLK_p[1]]
create_clock -period "100MHz" [get_ports FMCP_REFCLK_p[2]]
create_clock -period "148.5MHz" [get_ports FMCP_REFCLK_p[3]]
# PCIE
create_clock -period 10 [get_ports PCIE_REFCLK_p]
# QSFP28
create_clock -period "156.25MHz" [get_ports QSFP28_REFCLK_p[0]]
create_clock -period "184.32MHz" [get_ports QSFP28_REFCLK_p[1]]


#**************************************************************
# This .sdc file is created by Terasic Tool.
# Users are recommended to modify this file to match users logic.
#**************************************************************

#**************************************************************
# Create Clock
#**************************************************************
create_clock -period "297.00 MHz" -name TX_PCLK [get_ports TX_PCLK]
#create_clock -period "148.500 MHz" -name RX_PCLK [get_ports RX_PCLK]

#create_generated_clock -source [get_pins tx_pll_inst|pll_inst|iopll_0 ~outclk_0 ] 
#                       -name HDMI_TX_PCLK [get_ports TX_PCLK]

create_generated_clock -source [get_pins tx_pll_inst|pll_inst|altera_pll_i|general[1].gpll~PLL_OUTPUT_COUNTER|divclk] \
                       -name HDMI_TX_PCLK [get_ports TX_PCLK]

create_clock -period "148.500 MHz" -name HDMI_RX_PCLK [get_ports RX_PCLK]
create_clock -period "148.500 MHz" -name HDMI_RX_PCLK_ext

set_clock_groups -logically_exclusive -group HDMI_TX_PCLK -group HDMI_RX_PCLK


#**************************************************************
# Create Generated Clock
#**************************************************************
derive_pll_clocks



#**************************************************************
# Set Clock Latency
#**************************************************************



#**************************************************************
# Set Clock Uncertainty
#**************************************************************
derive_clock_uncertainty



#**************************************************************
# Set Input Delay
#**************************************************************
#set_input_delay -min -1.0 -clock HDMI_RX_PCLK_ext [get_ports {RX_DE RX_HS RX_VS RX_RD[*] RX_GD[*] RX_BD[*]}] -clock_fall
#set_input_delay -max 0.1  -clock HDMI_RX_PCLK_ext [get_ports {RX_DE RX_HS RX_VS RX_RD[*] RX_GD[*] RX_BD[*]}] -clock_fall



#**************************************************************
# Set Output Delay
#**************************************************************
#set_output_delay -min -0.45 -clock HDMI_TX_PCLK [get_ports {TX_DE TX_HS TX_VS TX_RD[*] TX_GD[*] TX_BD[*]}] -clock_fall
#set_output_delay -max 1.36  -clock HDMI_TX_PCLK [get_ports {TX_DE TX_HS TX_VS TX_RD[*] TX_GD[*] TX_BD[*]}] -clock_fall



#**************************************************************
# Set Clock Groups
#**************************************************************
set_clock_groups -asynchronous \
    -group [get_clocks {CLK_50_B3A_p}] \
    -group [get_clocks {RX_PCLK}] \
    -group [get_clocks {tx_pll_inst|iopll_0|outclk*}]

