module CLOCKMEM ( 
input                RST_N , 
input                CLK ,
input [31:0]         CLK_FREQ ,
output reg  			CK_1HZ
) ;
//=======================================================
//  REG/WIRE declarations
//=======================================================
reg [31:0] CLK_DELAY  ;   
//=======================================================
//  Structural coding
//=======================================================

always @(negedge RST_N or posedge CLK )  
if (!RST_N )begin
  CLK_DELAY<=0;  
  CK_1HZ   <=0;  
end
else
begin
	if (CLK_DELAY> CLK_FREQ/2) 
	begin 
		CLK_DELAY<=0;  
		CK_1HZ <=~CK_1HZ ;
	end
	else   
		CLK_DELAY <=CLK_DELAY+1;
end		
	
endmodule 
	
	