#**************************************************************
# This .sdc file is created by Terasic Tool.
# Users are recommended to modify this file to match users logic.
#**************************************************************

#**************************************************************
# Create Clock
#**************************************************************
create_clock -period "100.00000 MHz" [get_ports CLKUSR_100]
create_clock -period "50.00000 MHz" [get_ports CLK_50_B2H]
create_clock -period "50.00000 MHz" [get_ports CLK_50_B3H]
create_generated_clock -source [get_pins tx_pll_inst|iopll_0|altera_iopll_i|twentynm_pll|iopll_inst|outclk[0]] \
                       -name HDMI_TX_PCLK [get_ports TX_PCLK]

create_clock -period "148.500 MHz" -name HDMI_RX_PCLK [get_ports RX_PCLK]
create_clock -period "148.500 MHz" -name HDMI_RX_PCLK_ext

# for enhancing USB BlasterII to be reliable, 25MHz
create_clock -name {altera_reserved_tck} -period 40 {altera_reserved_tck}
set_input_delay -clock altera_reserved_tck -clock_fall 3 [get_ports altera_reserved_tdi]
set_input_delay -clock altera_reserved_tck -clock_fall 3 [get_ports altera_reserved_tms]
set_output_delay -clock altera_reserved_tck 3 [get_ports altera_reserved_tdo]

#**************************************************************
# Create Generated Clock
#**************************************************************
derive_pll_clocks



#**************************************************************
# Set Clock Latency
#**************************************************************



#**************************************************************
# Set Clock Uncertainty
#**************************************************************
derive_clock_uncertainty



#**************************************************************
# Set Input Delay
#**************************************************************
set_input_delay -min -1.0 -clock HDMI_RX_PCLK_ext [get_ports {RX_DE RX_HS RX_VS RX_RD[*] RX_GD[*] RX_BD[*]}] -clock_fall
set_input_delay -max 0.1  -clock HDMI_RX_PCLK_ext [get_ports {RX_DE RX_HS RX_VS RX_RD[*] RX_GD[*] RX_BD[*]}] -clock_fall



#**************************************************************
# Set Output Delay
#**************************************************************
set_output_delay -min -0.45 -clock HDMI_TX_PCLK [get_ports {TX_DE TX_HS TX_VS TX_RD[*] TX_GD[*] TX_BD[*]}] -clock_fall
set_output_delay -max 1.36  -clock HDMI_TX_PCLK [get_ports {TX_DE TX_HS TX_VS TX_RD[*] TX_GD[*] TX_BD[*]}] -clock_fall



#**************************************************************
# Set Clock Groups
#**************************************************************
set_clock_groups -asynchronous \
    -group [get_clocks {CLK_50_B3H}] \
    -group [get_clocks {HDMI_RX_PCLK}] \
    -group [get_clocks {tx_pll_inst|iopll_0|outclk*}]



#**************************************************************
# Set False Path
#**************************************************************



#**************************************************************
# Set Multicycle Path
#**************************************************************



#**************************************************************
# Set Maximum Delay
#**************************************************************



#**************************************************************
# Set Minimum Delay
#**************************************************************



#**************************************************************
# Set Input Transition
#**************************************************************



#**************************************************************
# Set Load
#**************************************************************



