
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

module a10soc_hdmi_rx_tx(

	//////////// CLOCK //////////
	input 		          		CLKUSR_100,
	input 		          		CLK_50_B2H,
	input 		          		CLK_50_B3H,

	//////////// KEY //////////
	input 		          		CPU_RESET_n,
	input 		     [1:0]		KEY,

	//////////// SW //////////
	input 		     [1:0]		SW,

	//////////// LED //////////
	output		     [1:0]		LED,

	//////////// SEG7 //////////
	output		          		HEX0_DP,
	output		     [6:0]		HEX0_D,
	output		          		HEX1_DP,
	output		     [6:0]		HEX1_D,

	//////////// Clock Generator Configure //////////
	inout 		          		CDCM6208_SCL,
	inout 		          		CDCM6208_SDA,

	//////////// FAN //////////
	input 		          		FAN_ALERT_n,

	//////////// FMC, FMC connect to HDMI-FMC //////////
	inout 		          		ADV7619_CSCL_FMC,
	inout 		          		ADV7619_CSDA_FMC,
	output		          		ADV7619_CS_n,
	input 		          		ADV7619_INT,
	output		          		ADV7619_RESET_n,
	output		     [1:0]		FMC_GA,
	output		          		FMC_I2C_SCL,
	inout 		          		FMC_I2C_SDA,
	output		          		RX0_DDC_SCL,
	inout 		          		RX0_DDC_SDA,
	inout 		          		RX1_DDC_SCL,
	inout 		          		RX1_DDC_SDA,
	input 		     [5:0]		RX_AP,
	input 		    [15:0]		RX_BD,
	input 		          		RX_DE,
	input 		    [15:0]		RX_GD,
	input 		          		RX_HS,
	input 		          		RX_MCLK,
	input 		          		RX_PCLK,
	input 		    [15:0]		RX_RD,
	input 		          		RX_SCLK,
	input 		          		RX_VS,
	inout 		          		SII9136_CSCL_FMC,
	inout 		          		SII9136_CSDA_FMC,
	input 		          		SII9136_INT,
	output		          		SII9136_RST_n,
	output		    [11:0]		TX_BD,
	output		          		TX_DE,
	output		          		TX_DSR3L,
	output		          		TX_DSR3R,
	output		    [11:0]		TX_GD,
	output		          		TX_HS,
	output		     [3:0]		TX_I2S,
	output		          		TX_MCLK,
	output		          		TX_PCLK,
	output		    [11:0]		TX_RD,
	output		          		TX_SCK,
	output		          		TX_SPDIF,
	output		          		TX_VS,
	output		          		TX_WS

);

//=======================================================
//  REG/WIRE declarations
//=======================================================
wire reset_n;
wire [23: 0] disp_data;
wire disp_clk;
wire disp_hs;
wire disp_vs;
wire disp_de;

//=======================================================
//  Structural coding
//=======================================================
assign ADV7619_CS_n = 1'b0;
assign reset_n = CPU_RESET_n;


//----heart
wire [1:0] HZ ; 
CLOCKMEM CK0( .RST_N(KEY[1]),.CLK(CLK_50_B2H),.CLK_FREQ ( 50_000_000),.CK_1HZ(HZ[0]));
CLOCKMEM CK1( .RST_N(KEY[1]),.CLK(TX_PCLK   ),.CLK_FREQ (297_000_000),.CK_1HZ(HZ[1]));


//-----Display
assign LED = HZ ;

//---nios controller
hdmi_controller u0 (
             .in_clk_50_clk_clk ( CLK_50_B2H         ),                                          //                           clk_50_clk_in.clk
             .in_reset_reset_n  ( reset_n            ),                                       //                     clk_50_clk_in_reset.reset_n

             // HDMI TX
             .hdmi_tx_fmc_i2c_scl_external_connection_export (SII9136_CSCL_FMC),  // hdmi_tx_fmc_i2c_scl_external_connection.export
             .hdmi_tx_fmc_i2c_sda_external_connection_export (SII9136_CSDA_FMC),  // hdmi_tx_fmc_i2c_sda_external_connection.export
             .sii9136_int_external_connection_export   (SII9136_INT),             //         sii9136_int_external_connection.export
             .sii9136_rst_n_external_connection_export (SII9136_RST_n),           //       sii9136_rst_n_external_connection.export

             .i2c_scl_external_connection_export (ADV7619_CSCL_FMC),              //             i2c_scl_external_connection.export
             .i2c_sda_external_connection_export (ADV7619_CSDA_FMC),              //             i2c_sda_external_connection.export
             .sii9679_rst_external_connection_export (),                          //               sii9679_rst_external_connection.export
             .adv7619_rst_external_connection_export (ADV7619_RESET_n),           //         adv7619_rst_external_connection.export
             .rx0_edid_i2c_scl_external_connection_export (RX0_DDC_SCL),          //        edid_i2c_scl_external_connection.export
             .rx0_edid_i2c_sda_external_connection_export (RX0_DDC_SDA),          //        edid_i2c_sda_external_connection.export
             .rx1_edid_i2c_scl_external_connection_export (RX1_DDC_SCL),          //        edid_i2c_scl_external_connection.export
             .rx1_edid_i2c_sda_external_connection_export (RX1_DDC_SDA),          //        edid_i2c_sda_external_connection.export
             .adv7619_int_external_connection_export      (ADV7619_INT)           //         adv7619_int_external_connection.export

         );
			

//===== latch hdmi source video

wire [ 7: 0] RX_G0, RX_G1;
wire [ 7: 0] RX_B0, RX_B1;
wire [ 7: 0] RX_R0, RX_R1;
assign RX_G0[7: 0] = RX_RD[15: 8];
assign RX_B0[7: 0] = RX_RD[7: 0];
assign RX_R0[7: 0] = RX_GD[15: 8];
assign RX_G1[7: 0] = RX_GD[7: 0];
assign RX_B1[7: 0] = RX_BD[15: 8];
assign RX_R1[7: 0] = RX_BD[7: 0];


reg [26:0] pix0_0;
reg [26:0] pix0_1;

always @(posedge RX_PCLK)
begin
	pix0_0 <= {RX_DE,RX_HS,RX_VS,RX_R0, RX_G0,RX_B0};
	pix0_1 <= {RX_DE,RX_HS,RX_VS,RX_R1, RX_G1,RX_B1};
end

reg rdreq_ack;
wire [4: 0] rdusedw;
always @(posedge tx_clk_fr or negedge reset_n)
begin
	if (!reset_n)
		rdreq_ack <= 1'b0;
	else if (rdusedw >=  5'd12)
		rdreq_ack <= 1'b1;
end

wire [26:0] pix1_0;
wire [26:0] pix1_1;


fifo fifo_inst(

         .wrclk(RX_PCLK),
         .wrreq(1'b1),
			.data({pix0_1, pix0_0}),	// input x54(2 pixel)	 

         .rdclk(tx_clk_fr),
         .rdreq(rdreq_ack),
         .rdusedw(rdusedw),
			.q({pix1_1, pix1_0})	 // output   x54(2 pixel)	
     );
	  
reg [26:0] pix2_0;
reg [26:0] pix2_1;
  

always @(posedge tx_clk_fr)
begin
		pix2_0 <= pix1_0;
		pix2_1 <= pix1_1;
end	  


tx_gpio tx_gpio_inst (
    .din     ({pix2_1, pix2_0}),     //     din.export
    .pad_out ({TX_DE, TX_HS, TX_VS, TX_RD[11: 4], TX_GD[11: 4], TX_BD[11: 4]}), // pad_out.export
    .ck      (tx_clk_fr)       //      ck.export
);



wire tx_pll_locked;
wire tx_clk_fr;
pll tx_pll_inst (
        .refclk   (RX_PCLK),    //  refclk.clk
        .rst      (~KEY[0]),       //   reset.reset
        .outclk_0 (TX_PCLK),  // outclk0.clk
        .outclk_1 (tx_clk_fr),  // outclk1.clk
        .locked   (tx_pll_locked)    //  locked.export
    );



/////////////////////////////
//assign TX_PCLK   =  RX_PCLK;
//assign {TX_RD[11: 0], TX_GD[11: 0], TX_BD[11: 0]} = {rx_r, 4'b0, rx_g, 4'b0, rx_b, 4'b0};
assign {TX_RD[3: 0], TX_GD[3: 0], TX_BD[3: 0]} = {4'b0, 4'b0, 4'b0};



assign TX_WS = RX_AP[5];
assign TX_SCK = RX_SCLK;
assign TX_I2S = RX_AP[4: 1];
assign TX_MCLK = RX_MCLK;

assign TX_SPDIF = RX_AP[0];


endmodule
